SystemOrganization addCategory: #'SqSquare-Server-Snapshot'!
SystemOrganization addCategory: #'SqSquare-Server-Service'!
SystemOrganization addCategory: #'SqSquare-Server'!
SystemOrganization addCategory: #'SqSquare-Server-Storage'!
SystemOrganization addCategory: #'SqSquare-Server-Storage-Tests'!

!FileDirectory methodsFor: '*SqSquare-Server-enumeration' stamp: 'MU 2/7/2006 18:10'!
directoriesMatches: selectionBlock
	^self directoryEntries select: selectionBlock! !

!FileDirectory methodsFor: '*SqSquare-Server-enumeration' stamp: 'MU 2/7/2006 18:08'!
directoryEntries
	^self entries select: [:e | e isDirectory]! !

!FileDirectory methodsFor: '*SqSquare-Server-enumeration' stamp: 'MU 2/7/2006 18:08'!
fileEntries
	^self entries reject: [:e | e isDirectory]! !

!FileDirectory methodsFor: '*SqSquare-Server-enumeration' stamp: 'MU 2/7/2006 18:10'!
filesMatches: selectionBlock
	^self fileEntries select: selectionBlock! !

!FileDirectory methodsFor: '*SqSquare-Server-enumeration' stamp: 'MU 2/7/2006 18:24'!
latestFileMatches: selectionBlock
	| entries |
	entries _ self filesMatches: selectionBlock.
	entries ifEmpty: [^nil].
	^(entries sort: [:a :b | a modificationTime > b modificationTime]) first! !

Object subclass: #SqBoardServer
	instanceVariableNames: 'recordHolder broadcaster boardId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server'!

!SqBoardServer class methodsFor: 'instance creation' stamp: 'MU 1/20/2006 17:26'!
boardId: boardId 
	^ self new boardId: boardId;
		 yourself! !

!SqBoardServer methodsFor: 'actions' stamp: 'minami 1/28/2006 05:50'!
addEvent: aSqEvent
	self recordHolder add: aSqEvent! !

!SqBoardServer methodsFor: 'accessing' stamp: 'MU 1/20/2006 17:26'!
boardId
	^boardId! !

!SqBoardServer methodsFor: 'accessing' stamp: 'MU 1/20/2006 17:27'!
boardId: anUUID
	boardId _ anUUID! !

!SqBoardServer methodsFor: 'accessing' stamp: 'minami 2/28/2006 17:04'!
broadcaster
	broadcaster
		ifNil: [broadcaster _ SqBroadcaster new].
	^ broadcaster! !

!SqBoardServer methodsFor: 'accessing' stamp: 'minami 2/28/2006 17:06'!
broadcaster: aBroadcaster
	broadcaster _ aBroadcaster! !

!SqBoardServer methodsFor: 'actions' stamp: 'minami 2/28/2006 17:03'!
broadcast: evt
	self broadcaster ifNotNilDo: [:b | b add: evt]! !

!SqBoardServer methodsFor: 'actions' stamp: 'mu 3/8/2006 11:28'!
close
	self stop.
	self initialize! !

!SqBoardServer methodsFor: 'snapshot' stamp: 'mu 3/7/2006 15:10'!
createSnapshot
	| events st |
	events := self events.
	events isEmptyOrNil
		ifTrue: [^ nil].
	st := SqSnapshotTaker appendAll: events originalBoardId: boardId.
	^ st createSnapshot! !

!SqBoardServer methodsFor: 'accessing' stamp: 'MU 2/24/2006 12:31'!
db
	^SqSquareDB default! !

!SqBoardServer methodsFor: 'snapshot' stamp: 'MU 2/17/2006 14:18'!
deleteAllSnapshots
	| dir entries |
	dir := SqSettings snapshotDirectory.
	entries _ dir filesMatches: [:each | each name beginsWith: self boardId asString].
	entries do: [:each | dir deleteFileNamed: each name].! !

!SqBoardServer methodsFor: 'actions' stamp: 'mu 3/6/2006 11:04'!
dumpUpToEnd
	| oldEvents |
	oldEvents _ self recordHolder dumpUpToEnd.
	self db addEvents: oldEvents to: self boardId ! !

!SqBoardServer methodsFor: 'actions' stamp: 'mu 3/7/2006 15:10'!
events
	self recordHolder currentNumber = 0 ifTrue: [^#()].
	^self eventsFrom: 1 to: self recordHolder currentNumber! !

!SqBoardServer methodsFor: 'actions' stamp: 'MU 2/23/2006 17:34'!
eventsFrom: start to: end 
	| firstEventId dbEvents memEvents |
	
	firstEventId _ self recordHolder firstEventId.
	firstEventId < 0 ifTrue: [^self db eventsFrom: start to: end of: self boardId].
	firstEventId <= start ifTrue: [^self recordHolder eventsFrom: (start - firstEventId + 1) to: (end - start  + 1)].

	dbEvents _ self db eventsFrom: start to: (end min: firstEventId -1) of: self boardId.
	memEvents _ self recordHolder eventsFrom: 1 to: (end - dbEvents size - start + 1).
	^dbEvents , memEvents! !

!SqBoardServer methodsFor: 'initialize' stamp: 'minami 2/28/2006 17:03'!
initialize
	super initialize.
	recordHolder _ nil.
	broadcaster _ nil! !

!SqBoardServer methodsFor: 'statistics' stamp: 'MU 1/20/2006 17:06'!
inspectConnections
	^ SqPassiveConnection incomingConnectionDict inspect! !

!SqBoardServer methodsFor: 'actions' stamp: 'MU 2/23/2006 17:05'!
latestEventsFrom: start 
	| firstEventId dbEvents memEvents |
	
	firstEventId _ self recordHolder firstEventId.
	firstEventId < 0 ifTrue: [^self db latestEventsFrom: start of: self boardId].
	firstEventId <= start ifTrue: [^self recordHolder latestEventsFrom: (start - firstEventId + 1)].

	dbEvents _ self db eventsFrom: start to: firstEventId -1 of: self boardId.
	memEvents _ self recordHolder latestEventsFrom: 1.
	^dbEvents , memEvents! !

!SqBoardServer methodsFor: 'actions' stamp: 'mu 3/7/2006 15:04'!
onMemoryEvents
	^self recordHolder events! !

!SqBoardServer methodsFor: 'printing' stamp: 'MU 2/9/2006 14:52'!
printOn: aStream
	aStream nextPutAll: 'a ', self className, '('.
	boardId ifNotNilDo: [:id | aStream nextPutAll: 'boardId: ', id asString].
	aStream nextPutAll: ')'! !

!SqBoardServer methodsFor: 'accessing' stamp: 'MU 1/20/2006 17:06'!
recordHolder
	recordHolder ifNil: [recordHolder := SqEventRecordHolder new].
	^ recordHolder! !

!SqBoardServer methodsFor: 'actions' stamp: 'MU 2/9/2006 14:58'!
resetEventRecords
	recordHolder ifNotNilDo: [:rh | rh resetEventRecords]! !

!SqBoardServer methodsFor: 'actions' stamp: 'MU 2/9/2006 15:43'!
saveSnapshot
	| dir snapshot bytes fStream |
	dir := SqSettings snapshotDirectory.
	snapshot := self createSnapshot.
	snapshot
		ifNotNilDo: [:sn | 
			bytes := RmtStreamer stream: sn by: #DataStream.
			fStream := dir forceNewFileNamed: sn first asString , '@' , sn second asString.
			fStream binary.
			[fStream nextPutAll: bytes]
				ensure: [fStream close]]! !

!SqBoardServer methodsFor: 'running' stamp: 'MU 3/1/2006 10:11'!
start
	self stop.
	self broadcaster start.
! !

!SqBoardServer methodsFor: 'running' stamp: 'MU 3/1/2006 10:11'!
stop
	self broadcaster stop.
	self broadcaster: nil.! !

Object subclass: #SqManager
	instanceVariableNames: 'db'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server-Service'!

SqManager subclass: #SqBoardManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server-Service'!

!SqBoardManager methodsFor: 'accessing' stamp: 'MU 2/22/2006 15:43'!
boards
	^self db groups! !

!SqBoardManager methodsFor: 'actions' stamp: 'MU 2/22/2006 15:12'!
createNewBoard: boardName
	| bd |
	self db ifNil: [^nil].

	bd _ SqBoard id: UUID new name: boardName.
	self db registerGroup: bd.
	^ bd! !

!SqBoardManager methodsFor: 'actions' stamp: 'MU 2/22/2006 15:16'!
getAllEventsOf: boardId
	| boardServer |
	boardServer _ SqServer default boardServerAt: boardId ifAbsent: [^#()].
	^boardServer events! !

!SqBoardManager methodsFor: 'actions' stamp: 'MU 2/22/2006 15:15'!
getEventsOf: boardId from: startIndex to: endIndex
	| boardServer |
	boardServer _ SqServer default boardServerAt: boardId ifAbsent: [^#()].
	^boardServer eventsFrom: startIndex to: endIndex  ! !

!SqBoardManager methodsFor: 'actions' stamp: 'MU 2/22/2006 15:15'!
getLatestEventsOf: boardId from: startIndex
	| boardServer |
	boardServer _ SqServer default boardServerAt: boardId ifAbsent: [^#()].
	^boardServer latestEventsFrom: startIndex! !

!SqBoardManager methodsFor: 'actions' stamp: 'MU 2/13/2006 14:18'!
getLatestSnapshotOf: boardId
	^SqSnapshotReader readLatestSnapshotOf: boardId.
	! !

!SqBoardManager methodsFor: 'actions' stamp: 'MU 2/22/2006 15:13'!
removeBoard: board 
	self db
		ifNil: [^ nil].
	^ self db removeGroup: board! !

SqManager subclass: #SqLoginManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server-Service'!

!SqLoginManager methodsFor: 'actions' stamp: 'MU 2/22/2006 15:38'!
login: userId password: password 
	| verified |
	self db ifNil: [^false].
	verified := self db verifyPassword: password forUser: userId.
	^ verified
		ifTrue: [SqAuthentication userId: userId]! !

!SqLoginManager methodsFor: 'actions' stamp: 'MU 2/22/2006 17:18'!
logout: authentication 
	"do we need this?"
	SqServer closeAllConnectionsByUser: authentication userId.
	^true! !

!SqLoginManager methodsFor: 'registering' stamp: 'MU 2/22/2006 15:09'!
register: userId password: password 
	| user |
	self db
		ifNil: [^ nil].
	user := SqUser id: userId password: password.
	self db registerUser: user.
	^ user! !

!SqLoginManager methodsFor: 'registering' stamp: 'MU 2/22/2006 15:07'!
unregister: userId
	
	^self db ifNotNilDo: [:d | d removeUser: (SqUser id: userId )]! !

!SqLoginManager methodsFor: 'accessing' stamp: 'MU 2/22/2006 15:02'!
users
	self db
		ifNil: [^ #()].
	^ self db users! !

!SqManager methodsFor: 'accessing' stamp: 'MU 2/22/2006 14:57'!
db
	db ifNil: [db _Smalltalk at: #SqSquareDB ifPresent:[:dbClass | dbClass default]].
	^db! !

!SqManager methodsFor: 'accessing' stamp: 'MU 2/22/2006 14:57'!
db: object
	db _ object! !

!SqManager methodsFor: 'initialize-release' stamp: 'MU 2/22/2006 14:57'!
initialize
	db _ nil! !

SqManager subclass: #SqUserManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server-Service'!

!SqUserManager methodsFor: 'registering' stamp: 'MU 2/22/2006 11:56'!
register: aSqUser
	self db registerUser: aSqUser.
	^ aSqUser! !

!SqUserManager methodsFor: 'registering' stamp: 'MU 2/21/2006 16:10'!
unregister: aSqUser
	self db removeUser: aSqUser.
	^ aSqUser! !

!SqUserManager methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:52'!
users
	^self db users! !

Object subclass: #SqServer
	instanceVariableNames: 'boardServers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server'!

SqServer class
	instanceVariableNames: 'default'!

!SqServer class methodsFor: 'connection management' stamp: 'MU 2/22/2006 17:22'!
activeUsers
	| users |
	users _ Set new.
	self allConnections do: [:each | users add: each accessId userId].
	^users ! !

!SqServer class methodsFor: 'connection management' stamp: 'minami 1/11/2006 15:41'!
allConnections
	^SqPassiveConnection connections! !

!SqServer class methodsFor: 'connection management' stamp: 'MU 2/22/2006 17:12'!
closeAllConnectionsByBoard: boardId 
	self
		closeAllConnectionsMatches: [:each | each accessId boardId = boardId]! !

!SqServer class methodsFor: 'connection management' stamp: 'MU 2/22/2006 17:12'!
closeAllConnectionsByUser: userId 
	self
		closeAllConnectionsMatches: [:each | each accessId userId = userId]! !

!SqServer class methodsFor: 'connection management' stamp: 'MU 2/22/2006 17:12'!
closeAllConnectionsMatches: aBlock
	| matched |
	matched _ self allConnections select: [:each | aBlock value: each].
	matched do: [:each | each close]! !

!SqServer class methodsFor: 'instance creation' stamp: 'minami 1/11/2006 13:53'!
default
	default ifNil: [default := super new].
	^ default! !

!SqServer class methodsFor: 'utilities' stamp: 'MU 2/22/2006 17:05'!
deleteAll
	^self default deleteAll! !

!SqServer class methodsFor: 'utilities' stamp: 'mu 3/7/2006 14:36'!
dumpAll
	^self default dumpAll! !

!SqServer class methodsFor: 'utilities' stamp: 'MU 2/22/2006 17:05'!
forgetAll
	^self default forgetAll! !

!SqServer class methodsFor: 'class initialization' stamp: 'minami 1/11/2006 13:54'!
initialize
	default := nil! !

!SqServer class methodsFor: 'utilities' stamp: 'mu 3/2/2006 12:07'!
resetStart
	self stop.
	self deleteAll.
	self initialize.
	self start.
	self default inspectAll.
	
	^ self default ! !

!SqServer class methodsFor: 'utilities' stamp: 'MU 2/22/2006 17:05'!
snapshotAll
	^self default snapshotAll! !

!SqServer class methodsFor: 'utilities' stamp: 'mu 3/2/2006 12:06'!
start
	self default start.
	^ self default ! !

!SqServer class methodsFor: 'utilities' stamp: 'mu 3/2/2006 12:06'!
stop
	self default stop.
	^ self default ! !

!SqServer methodsFor: 'accessing' stamp: 'minami 1/27/2006 15:16'!
boardServerAt: boardId 
	^ self boardServers
		at: boardId
		ifAbsent: []! !

!SqServer methodsFor: 'accessing' stamp: 'minami 1/27/2006 14:31'!
boardServerAt: boardId ifAbsentPut: aBlock
	^self boardServers 
		at: boardId 
		ifAbsentPut: aBlock ! !

!SqServer methodsFor: 'accessing' stamp: 'MU 2/6/2006 14:47'!
boardServerAt: boardId ifAbsent: aBlock
	^self boardServers 
		at: boardId 
		ifAbsent: aBlock ! !

!SqServer methodsFor: 'accessing' stamp: 'MU 1/20/2006 17:18'!
boardServers
	boardServers ifNil: [boardServers _ Dictionary new].
	^ boardServers! !

!SqServer methodsFor: 'debugging' stamp: 'MU 2/22/2006 17:19'!
connections
	^self class allConnections! !

!SqServer methodsFor: 'actions' stamp: 'MU 2/17/2006 14:05'!
deleteAll
	self boardServers do: [:e | e deleteAllSnapshots]
	! !

!SqServer methodsFor: 'actions' stamp: 'mu 3/7/2006 14:36'!
dumpAll
	self boardServers do: [:e | e dumpUpToEnd]
	! !

!SqServer methodsFor: 'actions' stamp: 'MU 2/24/2006 13:00'!
forgetAll
	self boardServers
		do: [:e | e resetEventRecords].

	self boardServers
		do: [:e | SqSquareDB default removeAllEventsFrom: e boardId]! !

!SqServer methodsFor: 'initialize' stamp: 'MU 1/20/2006 17:15'!
initialize
	super initialize.
! !

!SqServer methodsFor: 'debugging' stamp: 'MU 2/6/2006 15:54'!
inspectAll
	^ (Dictionary newFrom: 
		{ 
		  #services -> self services. 
		  #connections -> self connections.
		  #boardServers -> self boardServers
		}
	) inspect! !

!SqServer methodsFor: 'debugging' stamp: 'MU 2/6/2006 15:49'!
inspectBoardServers
	self boardServers inspect! !

!SqServer methodsFor: 'debugging' stamp: 'MU 2/6/2006 15:53'!
inspectConnections
	^self connections inspect! !

!SqServer methodsFor: 'debugging' stamp: 'MU 2/6/2006 15:53'!
inspectServices
	^ self services inspect! !

!SqServer methodsFor: 'debugging' stamp: 'MU 2/6/2006 15:53'!
services
	^ {SqPassiveConnection serviceForReceiveDict. SqPassiveConnection serviceForReturnDict}! !

!SqServer methodsFor: 'actions' stamp: 'MU 2/9/2006 15:47'!
snapshotAll
	self boardServers do: [:e | e saveSnapshot]
	! !

!SqServer methodsFor: 'running' stamp: 'MU 1/20/2006 17:36'!
start
	self stop.
	self startListening.
! !

!SqServer methodsFor: 'running' stamp: 'minami 1/27/2006 01:32'!
startListening
	SqPassiveConnection
		listenOn: SqSettings eventListenPort
		acceptorClass: SqBoardServerAcceptor! !

!SqServer methodsFor: 'running' stamp: 'mu 3/8/2006 11:25'!
stop
	SqPassiveConnection stopListening.

	self boardServers do: [:each | each stop].! !

Object subclass: #SqSnapshotReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server-Snapshot'!

!SqSnapshotReader class methodsFor: 'actions' stamp: 'MU 2/8/2006 10:44'!
loadLatestSnapshotOf: boardId
	"SqSnapshotReader loadLatestSnapshotOf: '6018c1ff-8b9c-b140-a2ed-d62f289f8dc5'"
	| entry |
	entry _ SqSettings snapshotDirectory latestFileMatches: [:e | e name beginsWith: boardId asString].
	entry ifNil: [^nil].
	^self loadSnapshotFileNamed: entry name! !

!SqSnapshotReader class methodsFor: 'actions' stamp: 'MU 2/7/2006 18:31'!
loadSnapshotFileNamed: localFileName 
	"SqSnapshotReader loadSnapshotFileNamed:
	'6018c1ff-8b9c-b140-a2ed-d62f289f8dc5@3316698773' "
	| loaded fileStr |
	[fileStr := SqSettings snapshotDirectory readOnlyFileNamed: localFileName.
	fileStr binary.
	loaded := self loadSnapshotFrom: fileStr]
		ensure: [fileStr
				ifNotNilDo: [:str | str close]].
	^ loaded! !

!SqSnapshotReader class methodsFor: 'actions' stamp: 'MU 2/6/2006 17:08'!
loadSnapshotFrom: fullSnapShotStream
	| snapshot board |
	snapshot _ self readSnapshotDataFrom: fullSnapShotStream.
	board _ CPlayer readSnapshotByteArray: snapshot last.
	board isHeadless: false.
	^board! !

!SqSnapshotReader class methodsFor: 'actions' stamp: 'MU 2/13/2006 13:32'!
readLatestSnapshotOf: boardId
	"SqSnapshotReader readLatestSnapshotOf: '6018c1ff-8b9c-b140-a2ed-d62f289f8dc5'"
	| entry |
	entry _ SqSettings snapshotDirectory latestFileMatches: [:e | e name beginsWith: boardId asString].
	entry ifNil: [^nil].
	^self readSnapshotDataFileNamed: entry name! !

!SqSnapshotReader class methodsFor: 'actions' stamp: 'MU 2/7/2006 18:31'!
readSnapshotDataFileNamed: localFileName
	| loaded fileStr |
	[fileStr _ SqSettings snapshotDirectory readOnlyFileNamed: localFileName.
	fileStr binary.
	loaded := self readSnapshotDataFrom: fileStr]
		ensure: [fileStr
				ifNotNilDo: [:str | str close]].
	^ loaded
! !

!SqSnapshotReader class methodsFor: 'actions' stamp: 'MU 2/6/2006 16:51'!
readSnapshotDataFrom: fullSnapShotStream
	| bytes snapshot |
	bytes _ fullSnapShotStream binary contents.
	snapshot _ RmtStreamer unstream: bytes by: #DataStream.
	^snapshot! !

Object subclass: #SqSnapshotTaker
	instanceVariableNames: 'events board originatorId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server-Snapshot'!

!SqSnapshotTaker class methodsFor: 'instance creation' stamp: 'MU 2/13/2006 14:56'!
appendAll: events originalBoardId: boardId
	| snapshot board inst version index |
	snapshot _ SqSnapshotReader readLatestSnapshotOf: boardId.
	snapshot ifNil: [^self withAll: events originalBoardId: boardId ].

	board _ CPlayer readSnapshotByteArray: snapshot last.
	inst _ self new board: board.
	
	version _ snapshot second.
	index _ (events detect: [:each | each eventId = version] ifNone:[]) ifNil: [0] ifNotNilDo: [:ev | ev eventId].
	
	index = 0 ifTrue: [^self withAll: events originalBoardId: boardId ]. "Maybe event quese was reset"
	
	inst events: (events copyFrom: index + 1 to: events size).
	inst originatorId: boardId.

	^inst! !

!SqSnapshotTaker class methodsFor: 'instance creation' stamp: 'MU 1/20/2006 13:57'!
withAll: events
	^self new events: events! !

!SqSnapshotTaker class methodsFor: 'instance creation' stamp: 'MU 2/6/2006 15:03'!
withAll: events originalBoardId: boardId 
	^ self new events: events;
		 originatorId: boardId! !

!SqSnapshotTaker methodsFor: 'accessing' stamp: 'MU 2/6/2006 17:06'!
board
	board
		ifNil: [board := SqEventRecordBoard new isHeadless: true;
						 yourself].
	^ board! !

!SqSnapshotTaker methodsFor: 'accessing' stamp: 'MU 1/20/2006 13:56'!
board: aBoard
	board _ aBoard! !

!SqSnapshotTaker methodsFor: 'actions' stamp: 'MU 2/7/2006 17:57'!
createSnapshot
	self events ifEmpty: [^nil].
	^ {self originatorId. self events last eventId. self rawSnapshot}! !

!SqSnapshotTaker methodsFor: 'accessing' stamp: 'MU 1/20/2006 13:58'!
events
	events ifNil: [events _ OrderedCollection new: 1000].
	^events! !

!SqSnapshotTaker methodsFor: 'accessing' stamp: 'MU 1/20/2006 13:56'!
events: aCollection
	events _ aCollection! !

!SqSnapshotTaker methodsFor: 'accessing' stamp: 'MU 2/13/2006 14:56'!
originatorId
	^originatorId! !

!SqSnapshotTaker methodsFor: 'accessing' stamp: 'MU 1/20/2006 14:02'!
originatorId: id
	originatorId _ id! !

!SqSnapshotTaker methodsFor: 'actions' stamp: 'MU 2/6/2006 17:07'!
rawSnapshot
	self board headlessBoardId: self originatorId.
	self events do: [:each |
		each execute: self board.
	].
	^self board asSnapshotData! !

SqAcceptor subclass: #SqBoardServerAcceptor
	instanceVariableNames: 'boardServer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server'!

!SqBoardServerAcceptor methodsFor: 'accessing' stamp: 'minami 1/28/2006 09:09'!
boardId
	^self accessId boardId! !

!SqBoardServerAcceptor methodsFor: 'accessing' stamp: 'MU 1/31/2006 18:57'!
boardServer
	^boardServer! !

!SqBoardServerAcceptor methodsFor: 'receiving' stamp: 'MU 2/6/2006 14:25'!
handleReceived: messageObject 
	| server |
	server := self boardServer.
	server ifNil: [SqWarning warnLog: 'Board not found'. ^self].
	server addEvent: messageObject.
	server broadcast: messageObject! !

!SqBoardServerAcceptor methodsFor: 'receiving' stamp: 'minami 2/28/2006 17:14'!
process: message 
	super process: message.
	message type == #negotiate
		ifTrue: [
			| bId |
			boardServer _  SqServer default 
				boardServerAt: (bId := self accessId boardId) 
				ifAbsentPut: [(SqBoardServer boardId: bId) start; yourself]].
! !

TdTimer subclass: #SqSnapshotDaemon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server-Snapshot'!

!SqSnapshotDaemon class methodsFor: 'constants' stamp: 'MU 2/6/2006 17:13'!
defaultIntervalSeconds
	^ 300! !

!SqSnapshotDaemon class methodsFor: 'constants' stamp: 'MU 2/6/2006 15:08'!
defaultPriority
	^ Processor userBackgroundPriority! !

!SqSnapshotDaemon methodsFor: 'actions' stamp: 'mu 3/8/2006 11:36'!
perform
	"SqSnapshotDaemon default start" 
	"SqSnapshotDaemon default stop"
	
	self saveSnapshots! !

!SqSnapshotDaemon methodsFor: 'actions' stamp: 'MU 2/9/2006 15:46'!
saveSnapshots
	SqSettings isServer
		ifFalse: [^ self].
	SqServer default boardServers
		do: [:each | each saveSnapshot]! !

SBObjectDB subclass: #SqSquareDB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server-Storage'!

!SqSquareDB class methodsFor: 'class initialization' stamp: 'MU 2/27/2006 14:12'!
createDb
	"SqSquareDB createDb"
	self default dbAccessorClass initialize.
	self registerDefaults! !

!SqSquareDB class methodsFor: 'utilities' stamp: 'minami 2/22/2006 16:46'!
defaultUsers

	^ {
		{'aaa'. 'bbb'}. 
		{'bbb'. 'ccc'}. 
		{'ccc'. 'ddd'}.

		{'user01'. 'user01'}.
		{'user02'. 'user02'}.
		{'user03'. 'user03'}.
		{'user04'. 'user04'}.
		{'user05'. 'user05'}.
		{'user06'. 'user06'}.
		{'user07'. 'user07'}.
		{'user08'. 'user08'}.
		{'user09'. 'user09'}.
		{'user10'. 'user10'}.
	}! !

!SqSquareDB class methodsFor: 'utilities' stamp: 'MU 2/21/2006 16:05'!
registerDefaults
	"SqSquareDB registerDefaults"
	self registerDefaultUsers! !

!SqSquareDB class methodsFor: 'utilities' stamp: 'MU 2/27/2006 12:54'!
registerDefaultUsers

	self default users isEmpty ifFalse: [^self].
	 
	self defaultUsers
		do: [:each | self default
				registerUser: (SqUser id: each first password: each second)].
	self default
		registerUser: ((SqUser id: 'root' password: 'arakeita')
				isAdmin: true)! !

!SqSquareDB methodsFor: 'event management' stamp: 'MU 2/21/2006 16:55'!
addEvents: events to: boardId 
	self
		containerNamed: self eventsKey
		at: boardId
		addAll: events
		ifAbsentCreateClass: OrderedCollection! !

!SqSquareDB methodsFor: 'event management' stamp: 'MU 2/23/2006 12:03'!
allEventsOf: boardId 
	| ret |
	ret := self containerNamed: self eventsKey at: boardId.
	^ ret
		ifNil: [#()]
		ifNotNil: [ret]! !

!SqSquareDB methodsFor: 'event management' stamp: 'MU 2/24/2006 12:32'!
eventsFrom: start to: end of: boardId 
	| events |
	events := #().
	self
		readDo: [:tra | 
			| dict allEvents | 
			dict := self containerNamed: self eventsKey on: tra.
			allEvents := dict
						ifNotNil: [(dict
								at: boardId
								ifAbsent: [#()]) yourself].
			events := self
						safeEventsCopyFrom: start
						to: end
						using: allEvents].
	^ events! !

!SqSquareDB methodsFor: 'constants' stamp: 'MU 2/21/2006 16:49'!
eventsKey
	^'events'! !

!SqSquareDB methodsFor: 'group management' stamp: 'MU 2/21/2006 16:36'!
groups
	^self allContainerContentsNamed: self groupsKey! !

!SqSquareDB methodsFor: 'constants' stamp: 'MU 2/21/2006 16:49'!
groupsKey
	^'groups'! !

!SqSquareDB methodsFor: 'initialize' stamp: 'MU 2/21/2006 16:49'!
initContainers
	"SqSquareDB default initContainers"
	self containerNamed: self eventsKey ifNoContainerCreateBTreeDict: self keySize ! !

!SqSquareDB methodsFor: 'initialize' stamp: 'MU 2/21/2006 16:48'!
initialize
	super initialize.
	self initContainers! !

!SqSquareDB methodsFor: 'event management' stamp: 'MU 2/24/2006 12:32'!
latestEventsFrom: start of: boardId 
	| events |
	events := #().
	self
		readDo: [:tra | 
			| dict allEvents | 
			dict := self containerNamed: self eventsKey on: tra.
			allEvents := dict
						ifNotNil: [(dict
								at: boardId
								ifAbsent: [#()]) yourself].
			events := self
						safeEventsCopyFrom: start
						to: allEvents size
						using: allEvents].
	^ events! !

!SqSquareDB methodsFor: 'private' stamp: 'MU 2/23/2006 15:15'!
outOfRangeFrom: start to: end for: events 
	| outOfRange |
	outOfRange := SqOutOfRange
				from: start
				to: end
				actualFrom: (events
						ifEmpty: [-1]
						ifNotEmpty: [events first eventId])
				to: events size.
	^ outOfRange! !

!SqSquareDB methodsFor: 'group management' stamp: 'MU 2/21/2006 16:32'!
registerGroup: aGroup
	self
		containerNamed: self groupsKey
		at: aGroup id
		put: aGroup! !

!SqSquareDB methodsFor: 'event management' stamp: 'MU 2/23/2006 11:49'!
removeAllEventsFrom: boardId 
	self
		containerNamed: self eventsKey
		removeKey: boardId
		ifAbsent: []! !

!SqSquareDB methodsFor: 'group management' stamp: 'MU 2/22/2006 14:21'!
removeAllGroups
	^self removeContainerNamed: self groupsKey! !

!SqSquareDB methodsFor: 'event management' stamp: 'MU 2/23/2006 12:00'!
removeEvents: events from: boardId 
	self
		containerNamed: self eventsKey
		at: boardId
		removeAll: events
		! !

!SqSquareDB methodsFor: 'group management' stamp: 'MU 2/21/2006 16:35'!
removeGroup: aGroup
	^self
		containerNamed: self groupsKey
		removeKey: aGroup id
		! !

!SqSquareDB methodsFor: 'private' stamp: 'MU 2/23/2006 15:15'!
safeEventsCopyFrom: start to: end using: allEvents 
	| events |
	[events := allEvents copyFrom: start to: end]
		on: Error
		do: [:ex | ex
				resignalAs: (self
						outOfRangeFrom: start
						to: end
						for: allEvents)].
	^ events! !

TestCase subclass: #SqDbTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server-Storage-Tests'!

!SqDbTest methodsFor: 'testing' stamp: 'MU 2/22/2006 14:23'!
testAddRemoveGroup
	"SqDbTest debug: #testAddRemoveGroup"
	| db group1 group2 |
	
	db _ SqSquareDB default.
	group1 _ SqBoard id: UUID new name: 'NewBoard1'.
	group2 _ SqBoard id: UUID new name: 'NewBoard2'.
	db registerGroup: group1.
	db registerGroup: group2.

	self should: [(db groups collect: [:each | each name]) asArray sort = #('NewBoard1' 'NewBoard2')].

	db removeGroup: group1.
	db removeGroup: group2.

	self should: [db groups isEmpty]
	! !

ApplicationService subclass: #SqBroadcaster
	instanceVariableNames: 'eventQueue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server'!

!SqBroadcaster class methodsFor: 'accessing' stamp: 'MU 3/1/2006 10:10'!
defaultPriority

	^Processor userInterruptPriority ! !

!SqBroadcaster methodsFor: 'adding' stamp: 'minami 2/28/2006 16:49'!
add: aEvent
	self eventQueue nextPut: aEvent! !

!SqBroadcaster methodsFor: 'actions' stamp: 'mu 3/7/2006 17:13'!
broadcast
	| event |
	event := self eventQueue next.
	event ifNil: [^self].
	SqServer allConnections
		do: [:con | 
			con send: event.
			Processor yield]! !

!SqBroadcaster methodsFor: 'accessing' stamp: 'minami 2/28/2006 16:55'!
eventQueue
	^ eventQueue! !

!SqBroadcaster methodsFor: 'initialize-release' stamp: 'mu 3/7/2006 17:13'!
initialize
	super initialize.

	eventQueue := SharedQueue2 new: 100.! !

!SqBroadcaster methodsFor: 'initialize-release' stamp: 'mu 3/7/2006 17:13'!
release
	eventQueue ifNotNilDo: [:q | q release].! !

!SqBroadcaster methodsFor: 'running' stamp: 'minami 2/28/2006 16:29'!
runWhile: aBlock
	[aBlock value] 
		whileTrue: [self broadcast]! !

!SqBroadcaster methodsFor: 'running' stamp: 'MU 3/1/2006 10:33'!
stop
	super stop.
	self release! !

RmtRpcAcceptor subclass: #SqRpcDispatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Server'!

!SqRpcDispatcher class methodsFor: 'class initialization' stamp: 'MU 1/20/2006 16:39'!
initialize
	"SqRpcDispatcher initialize"
	super initialize.
	receiverDictionary _ Dictionary new.
	self registerAllServices.

	self start! !

!SqRpcDispatcher class methodsFor: 'registering' stamp: 'minami 2/23/2006 11:41'!
registerAllServices
	"SqRpcDispatcher registerAllServices"
	self receiverDictionary at: #loginService put: SqLoginManager new.
	self receiverDictionary at: #userService put: SqUserManager new.
	self receiverDictionary at: #boardService put: SqBoardManager new.! !

!SqRpcDispatcher class methodsFor: 'actions' stamp: 'MU 1/20/2006 16:17'!
start
	"SqRpcDispatcher start"

	service _ (RmtTcpService on: SqSettings rpcListenPort) acceptorClass: self.
	service start! !

!SqRpcDispatcher class methodsFor: 'actions' stamp: 'MU 2/23/2006 18:18'!
stop
	"SqRpcDispatcher stop"
	service
		ifNotNilDo: [:ser | ser stop]! !
SqServer initialize!
SqRpcDispatcher initialize!
